﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Syncfusion.UI.Xaml.Grid.Helpers;

namespace DetailsView_NestedLevel
{
    public class CommandTEST : ICommand
    {
        int rowIndex = 2;
        public bool CanExecute(object parameter)
        {
            SfDataGrid datagrid = parameter as SfDataGrid;
           if(datagrid.DetailsViewDefinition.Count >= 0)
           {
               int recordIndex = datagrid.ResolveToRecordIndex(rowIndex);
               datagrid.ExpandDetailsViewAt(recordIndex);
               //Get the Details view based upon the recordIndex and Column name
               SfDataGrid DetailsViewGrid = datagrid.GetDetailsViewGrid(recordIndex, "OrderDetails");
               ObservableCollection<OrderInfo> OrderDetails = (datagrid.DataContext as ViewModel).Source[recordIndex].OrderDetails;
               if (OrderDetails == null)
               {
                   OrderDetails = new ObservableCollection<OrderInfo>();
                   OrderDetails.Add(new OrderInfo() { OrderID = 10001, CustomerID = 1, Quantity = 2, ProductDetails = null, UnitPrice = 15.0 });
               }
               else
                   OrderDetails.Insert(0, new OrderInfo() { OrderID = 10001, CustomerID = 1, Quantity = 2, ProductDetails = null, UnitPrice = 15.0 });

               DetailsViewGrid.SelectedItem = OrderDetails[0] as OrderInfo;

               (App.Current.MainWindow as MainWindow).SelectedItem.Text = (DetailsViewGrid.CurrentItem as OrderInfo).OrderID.ToString();
               (App.Current.MainWindow as MainWindow).CurrentItem.Text = (DetailsViewGrid.SelectedItem as OrderInfo).CustomerID.ToString();
               rowIndex += 2;
            }

            return false;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {

        }
    }
}
