﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;

namespace DetailsView_NestedLevel
{
    public class ProductInfo : INotifyPropertyChanged, IDataErrorInfo
    {
        #region private members

        private int _orderID;
        private int _ProductID;
        private double _discount;

        #endregion

        #region public properties

        [Range(11, 14, ErrorMessage = "OrderID can hold value between 11 and 14")]

        public int OrderID
        {
            get
            {
                return _orderID;
            }
            set
            {
                _orderID = value;
                RaisePropertyChanged("OrderID");
            }
        }

        public double Discount
        {
            get
            {
                return _discount;
            }
            set
            {
                _discount = value;
                RaisePropertyChanged("Discount");
            }
        }

        public int ProductID
        {
            get
            {
                return _ProductID;
            }
            set
            {
                _ProductID = value;
                RaisePropertyChanged("ProductID");
            }
        }

        #endregion

        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
        public event PropertyChangedEventHandler PropertyChanged;
        [Display(AutoGenerateField=false)]
        public string Error
        {
            get { return null; }
        }

        public string this[string columnName]
        {
            get
            {
                if (columnName.Equals("Discount"))
                {
                    if (this.Discount < 10.0)
                        return null;
                    else
                        return "Discount sholud less than 10";
                }
                return null;
            }
        }
    }
}
