﻿using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ComponentModel;
using System.Windows;
using System.Collections.ObjectModel;
using System.Collections;
using Syncfusion.Data.Extensions;
using System.Data;
using System.Windows.Input;


namespace DetailsView_NestedLevel
{
    public class ViewModel : INotifyPropertyChanged
    {
        ObservableCollection<Employee> source;
        protected EmployeeInfoRespository repository;
        protected int Count = 10;



        #region public properties


        ICommand _messageCommand = new CommandTEST();
        public ICommand ViewCurrentCommand
        {
            get { return _messageCommand; }
            set { _messageCommand = value; }
        }
        #endregion


        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }
        public event PropertyChangedEventHandler PropertyChanged;
        public ViewModel()
            : base()
        {
            repository = new EmployeeInfoRespository();
            source = repository.GetEmployeesDetails(Count);
        }

        public ObservableCollection<Employee> Source
        {
            get
            {
                return source;
            }
            set
            {
                source = value;
                RaisePropertyChanged("Source");
            }
        }
        private ICommand _clickCommand;
        public ICommand ClickCommand
        {
            get
            {
                return _clickCommand ?? (_clickCommand = new CommandHandler(() => AddRecord(), true));
            }
        }
        private bool _canExecute;
        public void AddRecord()
        {

            var r = Source[0];
            Source.Add(r);
        }
    }
    public class CommandHandler : ICommand
    {
        private Action _action;
        private bool _canExecute;
        public CommandHandler(Action action, bool canExecute)
        {
            _action = action;
            _canExecute = canExecute;
        }

        public bool CanExecute(object parameter)
        {
            return _canExecute;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            _action();
        }
    }
}

